WLJspc (Apache Ant API)
Date: 2018-07-10

org.apache.tools.ant.taskdefs.optional.jsp

## Class WLJspc

- java.lang.Object
- - org.apache.tools.ant.ProjectComponent
  - - org.apache.tools.ant.Task
    - - org.apache.tools.ant.taskdefs.MatchingTask
      - - org.apache.tools.ant.taskdefs.optional.jsp.WLJspc

- All Implemented Interfaces:
    java.lang.Cloneable, SelectorContainer

      public class WLJspc
      extends MatchingTask

  Precompiles JSP's using WebLogic's JSP compiler (weblogic.jspc). Tested only on Weblogic 4.5.1 - NT4.0 and Solaris 5.7 required attributes src : root of source tree for JSP, ie, the document root for your weblogic server dest : root of destination directory, what you have set as WorkingDir in the weblogic properties package : start package name under which your JSP's would be compiled other attributes classpath A classpath should be set which contains the weblogic classes as well as all application classes referenced by the JSP. The system classpath is also appended when the jspc is called, so you may choose to put everything in the classpath while calling Ant. However, since presumably the JSP's will reference classes being build by Ant, it would be better to explicitly add the classpath in the task The task checks timestamps on the JSP's and the generated classes, and compiles only those files that have changed. It follows the weblogic naming convention of putting classes in _dirName/_fileName.class for dirname/fileName.jsp Limitation: It compiles the files thru the Classic compiler only. Limitation: Since it is my experience that weblogic jspc throws out of memory error on being given too many files at one go, it is called multiple times with one jsp file each.

       example
       <target name="jspcompile" depends="compile">
         <wljspc src="c:\\weblogic\\myserver\\public_html"
                 dest="c:\\weblogic\\myserver\\serverclasses" package="myapp.jsp">
         <classpath>
                <pathelement location="${weblogic.classpath}" />
                 <pathelement path="${compile.dest}" />
            </classpath>

         </wljspc>
       </target>

- - ### Field Summary

    - ### Fields inherited from class org.apache.tools.ant.taskdefs.MatchingTask

      `fileset`

    - ### Fields inherited from class org.apache.tools.ant.Task

      `target, taskName, taskType, wrapper`

    - ### Fields inherited from class org.apache.tools.ant.ProjectComponent

      `description, location, project`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WLJspc()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Path` | `createClasspath()` Maybe creates a nested classpath element.
    `void` | `execute()` Run the task.
    `protected java.lang.String` | `replaceString(java.lang.String inpString, java.lang.String escapeChars, java.lang.String replaceChars)` Replace occurrences of a string with a replacement string.
    `protected void` | `scanDir(java.lang.String[] files)` Scan the array of files and add the jsp files that need to be compiled to the filesToDo field.
    `void` | `setClasspath(Path classpath)` Set the classpath to be used for this compilation.
    `void` | `setDest(java.io.File dirName)` Set the directory containing the source jsp's
    `void` | `setPackage(java.lang.String packageName)` Set the package under which the compiled classes go
    `void` | `setSrc(java.io.File dirName)` Set the directory containing the source jsp's

    - ### Methods inherited from class org.apache.tools.ant.taskdefs.MatchingTask

      `add, addAnd, addContains, addContainsRegexp, addCustom, addDate, addDepend, addDepth, addDifferent, addFilename, addMajority, addModified, addNone, addNot, addOr, addPresent, addSelector, addSize, addType, appendSelector, createExclude, createExcludesFile, createInclude, createIncludesFile, createPatternSet, getDirectoryScanner, getImplicitFileSet, getSelectors, hasSelectors, selectorCount, selectorElements, setCaseSensitive, setDefaultexcludes, setExcludes, setExcludesfile, setFollowSymlinks, setIncludes, setIncludesfile, setProject, XsetIgnore, XsetItems`

    - ### Methods inherited from class org.apache.tools.ant.Task

      `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

    - ### Methods inherited from class org.apache.tools.ant.ProjectComponent

      `clone, getDescription, getLocation, getProject, setDescription, setLocation`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WLJspc

          public WLJspc()

  - ### Method Detail

    - #### execute

          public void execute()
                       throws BuildException

      Run the task.
      Overrides:
        `execute` in class `Task`
      Throws:
        `BuildException` - if there is an error.

    - #### setClasspath

          public void setClasspath(Path classpath)

      Set the classpath to be used for this compilation.
      Parameters:
        `classpath` - the classpath to use.

    - #### createClasspath

          public Path createClasspath()

      Maybe creates a nested classpath element.
      Returns:
        a path to be configured.

    - #### setSrc

          public void setSrc(java.io.File dirName)

      Set the directory containing the source jsp's
      Parameters:
        `dirName` - the directory containing the source jsp's

    - #### setDest

          public void setDest(java.io.File dirName)

      Set the directory containing the source jsp's
      Parameters:
        `dirName` - the directory containing the source jsp's

    - #### setPackage

          public void setPackage(java.lang.String packageName)

      Set the package under which the compiled classes go
      Parameters:
        `packageName` - the package name for the classes

    - #### scanDir

          protected void scanDir(java.lang.String[] files)

      Scan the array of files and add the jsp files that need to be compiled to the filesToDo field.
      Parameters:
        `files` - the files to scan.

    - #### replaceString

          protected java.lang.String replaceString(java.lang.String inpString,
                                                   java.lang.String escapeChars,
                                                   java.lang.String replaceChars)

      Replace occurrences of a string with a replacement string.
      Parameters:
        `inpString` - the string to convert.
        `escapeChars` - the string to replace.
        `replaceChars` - the string to place.
      Returns:
        the converted string.